;---------------------------------------------------------------------
; ASSEMBLY LANGUAGE VDI DEMO
;
; NOTE: IN ORDER TO KEEP THE CODE AS CLEAR AS POSSIBLE, NO ATTEMPT
;       HAS BEEN MADE TO OPTIMIZE THE PROGRAM. FOR EXAMPLE, EVERY
;       CALL TO A VDI FUNCTION SHOWS THE APPLICATION'S HANDLE,
;       VWS_HANDLE, BEING MOVED INTO THE CONTROL ARRAY. THIS MAY NOT
;       BE NECESSARY IN THE "REAL WORLD," AS ONCE THE HANDLE IS IN
;       THE ARRAY, IT IS NOT USUALLY OVERWRITTEN.
;
; DEVELOPED WITH DEVPAC2 ST.
; COPYRIGHT 1992 BY CLAYTON WALNUM
;---------------------------------------------------------------------

PTERM0          equ     0
CCONIN		equ	1
GETREZ		equ	4
MSHRINK         equ     74

APPL_INIT       equ     10
APPL_EXIT	equ	19
GRAF_HANDLE     equ     77
GRAF_MOUSE	equ	78

V_BAR		equ	1
V_ARC		equ	2
V_CLRWK         equ     3
V_PLINE		equ	6
V_PMARKER	equ	7
V_RBOX		equ	8
V_GTEXT		equ	8
GDP		equ	11
VST_HEIGHT	equ	12
VST_ROTATION	equ	13
VSL_TYPE	equ	15
VSL_WIDTH	equ	16
VSL_COLOR	equ	17
VSM_TYPE	equ	18
VSM_HEIGHT	equ	19
VSM_COLOR	equ	20
VST_COLOR	equ	22
VSF_INTERIOR	equ	23
VSF_STYLE	equ	24
VSF_COLOR	equ	25
V_OPNVWK        equ     100
V_CLSVWK        equ     101
VST_EFFECTS	equ	106
VSL_ENDS	equ	108
VRO_CPYFM	equ	109
V_SHOW_C	equ	122
V_HIDE_C	equ	123
VQ_MOUSE	equ	124

AES_OPCODE      equ     200
VDI_OPCODE      equ     115
BLACK		equ	1
REPLACE		equ	3
POINT_HAND	equ	3
LEFT_BUTTON	equ	1
RIGHT_BUTTON	equ	2

;--------------------------------------------------------------------
; This macro gets a single character from the keyboard, using the
; Cconin GEMDOS function.
;--------------------------------------------------------------------
get_char macro
        move    #CCONIN,-(sp)
        trap    #1
        addq.l  #2,sp
        endm

;--------------------------------------------------------------------
; MAIN PROGRAM
;--------------------------------------------------------------------
        text

; Calculate the size of the program area.

        move.l  a7,a5                   ; Save addr of TPA.
        lea     stack,sp                ; Load addr of our stack.
        
        move.l  4(a5),a5                ; Get addr of TPA.              
        move.l  12(a5),d0               ; Get len of text segment.
        add.l   20(a5),d0               ; Add len of data segment.
        add.l   28(a5),d0               ; Add len of BSS segment.
        add.l   #$100,d0                ; Add len of TPA. 

; Release unused memory back to the system.
        
        move.l  d0,-(sp)                ; Push size of program on stack.
        move.l  a5,-(sp)                ; Push program addr on stack.
        clr     -(sp)                   ; Clear dummy word on stack.    
        move    #MSHRINK,-(sp)          ; Push Mshrink opcode.
        trap    #1                      ; Call GEMDOS.
        add.l   #12,sp                  ; Reset stack pointer.

; Clear some fields of the global array.

        clr.l   ap_ptree        
        clr.l   ap_1resv
        clr.l   ap_2resv
        clr.l   ap_3resv
        clr.l   ap_4resv

; Call appl_init to initialize application.

        move    #APPL_INIT,control
        move    #0,control+2
        move    #1,control+4
        move    #0,control+6
        move    #0,control+8
        bsr     aes
        cmpi    #$FFFF,ap_id            ; Error?
        beq     end                     ; Yep.  Outta here.

; Get handle to screen device.

        move    #GRAF_HANDLE,control
        move    #0,control+2
        move    #5,control+4
        move    #0,control+6
        move    #0,control+8
        jsr     aes
        move    int_out,gr_handle       ; Save device handle.

; Open virtual workstation.

        move    #V_OPNVWK,control
        clr     control+2
        move    #11,control+6
        move    gr_handle,control+12    
        movea.l #int_in,a5              ; Get address of int_in.
        move    #9,d5                   ; Init loop counter.
loop:
        move    #1,(a5)+                ; Init int_in array.
        dbra    d5,loop
        move    #2,int_in+20
        jsr     vdi
        move    control+12,vws_handle   ; Save virtual device handle.

	move	#V_HIDE_C,control	; Hide mouse pointer.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi

;----------------------------------------------------------
; DEMONSTRATE POLYLINES
;----------------------------------------------------------

	move	#30,x1			; Set starting...
	move	#20,y1			; coords for...
	move	#280,x2			; polyline...
	move	#20,y2			; function.
	move	#1,width		; Set initial line width.
	
	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi

	move	#1,color		; Initialize starting color.
	clr	ends			; Set starting line end type.
lineloop:
	move	#VSL_COLOR,control	; Set line color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	color,int_in
	jsr	vdi
	
	move	#VSL_ENDS,control	; Set line end type.
	clr	control+2
	move	#2,control+6
	move	vws_handle,control+12
	move	ends,int_in		; End style for start of line.
	move	ends,int_in+2		; End style for end of line.
	jsr	vdi
	
	move	#VSL_WIDTH,control	; Set line width.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	move	width,pts_in
	clr	pts_in+2
	jsr	vdi
		
	move	#V_PLINE,control	; Draw polyline.
	move	#2,control+2
	clr	control+6
	move	vws_handle,control+12
	move	x1,pts_in
	move	y1,pts_in+2
	move	x2,pts_in+4
	move	y2,pts_in+6
	jsr	vdi
	
	addi	#10,y1			; Calc new coords for line.
	addi	#10,y2
	addq	#1,ends			; Calc new end style.
	addq	#2,width		; Calc new line width.
	addq	#1,color		; Calc new color.
	cmpi	#5,color
	blt	lineloop

	move	#VSL_WIDTH,control	; Set line width.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	move	#1,pts_in
	clr	pts_in+2
	jsr	vdi

	move	#VSL_ENDS,control	; Set line end type.
	clr	control+2
	move	#2,control+6
	move	vws_handle,control+12
	move	#0,int_in		; End style for start of line.
	move	#0,int_in+2		; End style for end of line.
	jsr	vdi
	
	move	#VSL_COLOR,control	; Set line color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	#1,int_in
	jsr	vdi

	move	#1,type			; Init line type.
lineloop2:
	move	#VSL_TYPE,control	; Set line type.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	type,int_in
	jsr	vdi

	addi	#10,y1
	addi	#10,y2
	
	move	#V_PLINE,control	; Draw polyline.
	move	#2,control+2
	clr	control+6
	move	vws_handle,control+12
	move	x1,pts_in
	move	y1,pts_in+2
	move	x2,pts_in+4
	move	y2,pts_in+6
	jsr	vdi
	
	addq	#1,type
	cmpi	#7,type
	blt	lineloop2

	get_char

;----------------------------------------------------------
; DEMONSTRATE ROUNDED RECTANGLES
;----------------------------------------------------------

	move	#10,x1			; Init the...
	move	#10,y1			; starting coords...
	move	#300,x2			; for the...
	move	#190,y2			; rectangle.
	move	#1,width		; Init line width.
	
	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi
	
	move	#VSL_TYPE,control	; Set line type.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	#1,int_in
	jsr	vdi

	move	#1,color		; Init line color.
recloop:
	move	#VSL_WIDTH,control	; Set line width.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	move	width,pts_in
	clr	pts_in+2
	jsr	vdi
	
	move	#VSL_COLOR,control	; Set line color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	color,int_in
	jsr	vdi

	move	#GDP,control		; Graphics primitive.
	move	#2,control+2
	clr	control+6
	move	#V_RBOX,control+10	; Rounded box.
	move	vws_handle,control+12
	move	x1,pts_in
	move	y1,pts_in+2
	move	x2,pts_in+4
	move	y2,pts_in+6
	jsr	vdi

	addq	#2,width		; Calc new line width.
	addi	#20,x1			; Calc new rectangle coords.
	addi	#20,y1
	subi	#10,x2
	subi	#10,y2
	addq	#1,color		; Calc new line color.
	cmpi	#7,color
	blt	recloop
	
	get_char

;----------------------------------------------------------
; DEMONSTRATE POLYMARKERS
;----------------------------------------------------------

	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi
	
	move	#10,y1			; Init marker Y coord.
	move	#1,type			; Init polymarker type.
polymloop:
	move	#VSM_TYPE,control	; Set marker type.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	type,int_in
	jsr	vdi
	
	move	#2,height		; Init marker height.
	move	#10,x1			; Init marker X coord.
	move	#1,color		; Init marker color.
polymloop2:	
	move	#VSM_COLOR,control	; Set marker color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	color,int_in
	jsr	vdi
	
	move	#VSM_HEIGHT,control	; Set marker height.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	clr	pts_in
	move	height,pts_in+2
	jsr	vdi

	move	#V_PMARKER,control	; Draw polymarker.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	move	x1,pts_in
	move	y1,pts_in+2
	jsr	vdi
	
	addi	#16,height		; Calc new marker height.
	addi	#60,x1			; Calc new X coord.
	addq	#1,color		; Calc new marker color.
	cmpi	#6,color
	blt	polymloop2
	
	addi	#35,y1			; Calc new Y coord.
	addq	#1,type			; Calc new marker type.
	cmpi	#7,type
	blt	polymloop
	
	get_char
	
;----------------------------------------------------------
; DEMONSTRATE ARCS
;----------------------------------------------------------

	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi

	move	#VSL_WIDTH,control	; Set line width.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	move	#3,pts_in
	clr	pts_in+2
	jsr	vdi

	move	#900,bang		; Init arc beginning angle.
	move	#0,eang			; Init arc ending angle.
	move	#10,radius		; Init arc radius.
	move	#1,color		; Init line color.
arcloop:
	move	#VSL_COLOR,control	; Set line color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	color,int_in
	jsr	vdi

	move	#GDP,control		; Draw arc.
	move	#4,control+2
	move	#2,control+6
	move	#V_ARC,control+10
	move	vws_handle,control+12
	move	bang,int_in
	move	eang,int_in+2
	move	#150,pts_in
	move	#100,pts_in+2
	clr	pts_in+4
	clr	pts_in+6
	clr	pts_in+8
	clr	pts_in+10
	move	radius,pts_in+12
	clr	pts_in+14
	jsr	vdi

	addi	#60,bang		; Calc new beginning angle.
	subi	#60,eang		; Calc new ending angle.
	addi	#20,radius		; Calc new radius.
	addq	#1,color		; Calc new color.
	cmpi	#6,color
	blt	arcloop
	
	get_char	

;----------------------------------------------------------
; DEMONSTRATE FILLS
;----------------------------------------------------------

	move	#50,x1			; Init coords...
	move	#30,y1			; for...
	move	#250,x2			; the bar...
	move	#170,y2			; function.
	move	#2,interior		; Init interior style.
	move.l	#25,d5			; Init fill style count.
fillloop:
	move	#VSF_COLOR,control	; Set fill color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	interior,int_in
	jsr	vdi
	
	move	#VSF_INTERIOR,control
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	interior,int_in
	jsr	vdi
	
	move	#1,style		; Init fill style.
fillloop2:
	move	#VSF_STYLE,control
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	style,int_in
	jsr	vdi
	
	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi
	
	move	#GDP,control		; Draw bar.
	move	#2,control+2
	clr	control+6
	move	#V_BAR,control+10
	move	vws_handle,control+12	
	move	x1,pts_in
	move	y1,pts_in+2
	move	x2,pts_in+4
	move	y2,pts_in+6
	jsr	vdi

	move	#60000,d0		; Loop so the image...
timerloop:				; stays on the screen...
	dbra	d0,timerloop		; for a while.

	addq	#1,style		; Calc next fill style.
	cmp	style,d5
	bge	fillloop2
	
	move	#13,d5			; Init fill style count.
	addq	#1,interior		; Calc next interior.
	cmpi	#4,interior
	blt	fillloop
	
	get_char

;----------------------------------------------------------
; DEMONSTRATE GRAPHIC TEXT
;----------------------------------------------------------

	move	#GETREZ,-(sp)		; Get screen resolution.
	trap	#14
	addq.l	#2,sp
	
	cmpi	#0,d0			; Low rez?
	bne	check_rez		; Nope.
	move	#1,h_factor		; Init rez-dependent variables.
	move	#1,v_factor
	move	#0,t_factor
	bra	do_effects
check_rez:
	cmpi	#1,d0			; Medium rez?
	bne	check_rez2		; Nope.
	move	#2,h_factor
	move	#1,v_factor
	move	#1,t_factor
	bra	do_effects
check_rez2:
	move	#2,h_factor		; Must be hi rez.
	move	#2,v_factor
	move	#1,t_factor
do_effects:
	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi
	
	move	#VST_COLOR,control	; Set text color.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	#BLACK,int_in
	jsr	vdi

	move	#4,height		; Init text height.
	cmpi	#2,v_factor		; Are we in high rez?
	bne	set_height		; Nope.
	move	#8,height
set_height:	
	move	#VST_HEIGHT,control	; Set text height.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	clr	pts_in
	move	height,pts_in+2
	jsr	vdi
	
	move	#1,b_effect		; Init effects variable.
	move	#5,d5			; Init text location.
	mulu	h_factor,d5
	move	d5,x
next_column:	
	move	#25,d5
	mulu	v_factor,d5
	move	d5,y	
	move	#1,n_effect		; Calc next effect.
next_effect:
	move	b_effect,d5
	or	n_effect,d5
	move	d5,effect
	
	move	#VST_EFFECTS,control	; Set text effect.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	effect,int_in
	jsr	vdi

	move	#V_GTEXT,control	; Print text onto screen.
	move	#1,control+2
	move	#7,control+6
	move	vws_handle,control+12
	move	x,pts_in
	move	y,pts_in+2
	move	#'E',int_in
	move	#'F',int_in+2
	move	#'F',int_in+4
	move	#'E',int_in+6
	move	#'C',int_in+8
	move	#'T',int_in+10
	move	#'S',int_in+12
	jsr	vdi
	
	lsl	n_effect		; Calc new effect value.
	move	#25,d5			; Calc new Y position.
	mulu	v_factor,d5
	add	d5,y
	
	move	#126,d5			; Calc maximum value of Y.
	mulu	v_factor,d5
	cmp	y,d5			; Are we at max Y?
	blt	next_x			; Yep. Go get new X.
	bra	next_effect		; Nope. Draw next effect.
next_x:
	lsl	b_effect		; Shift bits for next effect.
	move	#62,d5			; Calc new X position.
	mulu	h_factor,d5
	add	d5,x
	
	move	#260,d5			; Calc maximum X value.
	mulu	h_factor,d5
	cmp	x,d5			; Are we at max X?
	blt	effects_done		; Yep. All done.
	bra	next_column		; Nope. Draw next text column.
effects_done:
	get_char
		
;----------------------------------------------------------
; DEMONSTRATE GRAPHIC TEXT ROTATION
;----------------------------------------------------------

	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi

	move	#VST_HEIGHT,control	; Set text height.
	move	#1,control+2
	clr	control+6
	move	vws_handle,control+12
	clr	pts_in
	move	#8,pts_in+2
	jsr	vdi
	
	clr	angle			; Init text angle.
next_rotation:
	move	#VST_ROTATION,control	; Set text angle.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	angle,int_in
	jsr	vdi

	move	#160,d5			; Calc X coord for text.
	mulu	h_factor,d5
	move	d5,x
	move	#96,d5			; Calc Y coord for text.
	mulu	v_factor,d5
	move	d5,y
		
	move	#V_GTEXT,control	; Print text onto screen.
	move	#1,control+2
	move	#8,control+6
	move	vws_handle,control+12
	move	x,pts_in
	move	y,pts_in+2
	move	#'R',int_in
	move	#'O',int_in+2
	move	#'T',int_in+4
	move	#'A',int_in+6
	move	#'T',int_in+8
	move	#'I',int_in+10
	move	#'O',int_in+12
	move	#'N',int_in+14
	jsr	vdi

	add	#90,angle		; Calc new angle for text.
	cmp	#2701,angle		; At max angle?
	blt	next_rotation		; Nope.
	
	get_char

	move	#VST_ROTATION,control	; Reset normal text angle.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	#0,int_in
	jsr	vdi
			
;----------------------------------------------------------
; DEMONSTRATE RASTER OPERATIONS
;----------------------------------------------------------
raster:
	move	#V_CLRWK,control	; Clear screen.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi

	move	#GRAF_MOUSE,control	; Change mouse form to hand.
	move	#1,control+2
	move	#1,control+4
	move	#1,control+6
	clr	control+8
	move	#POINT_HAND,int_in
	move.l	#0,addr_in
	jsr	aes
	
	move	#50,x			; Init coords of icon.
	move	#50,y
raster_loop:
	
	move	#VRO_CPYFM,control	; Draw icon.
	move	#4,control+2
	move	#1,control+6
	move	vws_handle,control+12
	move.l	#mfdb_i,control+14	; Addr of source MFDB.
	move.l	#mfdb_s,control+18	; Addr of destination MFDB.
	move	#REPLACE,int_in		; Drawing mode.
	clr	pts_in			; X coord of icon upper left.
	clr	pts_in+2		; Y coord of icon upper left.
	move	#15,pts_in+4		; X coord of icon lower right.
	move	#17,pts_in+6		; Y coord of icon lower right.
	move	x,pts_in+8		; X coord of dest. upper left.
	move	y,pts_in+10		; Y coord of dest. upper left.
	move	x,d5			; Calc lower right X.
	addi	#15,d5
	move	d5,pts_in+12		; X coord of dest. lower right.
	move	y,d5			; Calc lower right Y.
	add	#17,d5
	move	d5,pts_in+14		; Y coord of dest. lower right.
	jsr	vdi

	move	#V_SHOW_C,control	; Show mouse pointer.
	clr	control+2
	move	#1,control+6
	move	vws_handle,control+12
	move	#1,int_in
	jsr	vdi
		
track_mouse:
	move	#VQ_MOUSE,control	; Get mouse state.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi
	
	cmpi	#LEFT_BUTTON,int_out	; Pressed left button?
	beq	get_mouse_coords	; Yep. Get new mouse coords.
	cmpi	#RIGHT_BUTTON,int_out	; Pressed right button?
	beq	out			; Yep. All done.
	bra	track_mouse		; Nope. Check buttons again.

get_mouse_coords:
	move	pts_out,x		; Get new mouse coords.
	move	pts_out+2,y

	move	#V_HIDE_C,control	; Hide mouse pointer.
	clr	control+2
	clr	control+6
	move	vws_handle,control+12
	jsr	vdi
	
	bra	raster_loop
		
; Close the virtual workstation.

out:
        move    #V_CLSVWK,control
        clr     control+2
        clr     control+6
        move    vws_handle,control+12
        jsr     vdi
                
; Close down application.

exit:
        move    #APPL_EXIT,control
        move    #0,control+2
        move    #1,control+4
        move    #0,control+6
        move    #0,control+8
        bsr     aes
        
end:
        move.w  #PTERM0,-(sp)           ; Back to desktop.
        trap    #1

;--------------------------------------------------------------------
; This subroutine calls the AES.  Before calling this subroutine, the
; program must have correctly initialized the AES control, int_in,
; and addr_in arrays.
;
; Input:        Appropriate values in the int_in, addr_in, and
;               control arrays.
; Output:       Appropriate values in the int_out, addr_out, and
;               global arrays.
; Regs changed: NONE
; Uses: apb, global, int_in, int_out, addr_in, addr_out
;--------------------------------------------------------------------
aes:
        movem.l a0-a7/d0-d7,-(sp)       ; Save registers.
        move.l  #apb,d1                 ; Load addr of apb.
        move.w  #AES_OPCODE,d0          ; Load AES opcode.
        trap    #2                      ; Call AES.
        movem.l (sp)+,a0-a7/d0-d7       ; Restore registers.
        rts

;--------------------------------------------------------------------
; This subroutine calls the VDI. Before calling this subroutine, the
; program must have correctly initialized the VDI control, intin,
; and ptsin arrays.
;
; Input:        Appropriate values in the intin, ptsin, and
;               control arrays.
; Output:       Appropriate values in the intout and ptsout arrays.
; Regs changed: NONE
; Uses: vpb, intin, intout, ptsin, ptsout
;--------------------------------------------------------------------
vdi:
        movem.l a0-a7/d0-d7,-(sp)       ; Save registers.
        move.l  #vpb,d1                 ; Load addr of vpb.
        move.w  #VDI_OPCODE,d0          ; Load VDI opcode.
        trap    #2                      ; Call VDI.
        movem.l (sp)+,a0-a7/d0-d7       ; Restore registers.
        rts

        data
        
        even

; AES and VDI parameter block arrays.

apb:    dc.l    control,global,int_in,int_out,addr_in,addr_out
vpb:    dc.l    control,int_in,pts_in,int_out,pts_out

; MFDB for icon.

mfdb_i:	dc.l	icon	; Address of data.
	dc.w	16	; Width of icon.
	dc.w	18	; Height of icon.
	dc.w	1	; Width/16
	dc.w	0	; Image format.
	dc.w	4	; Number of bit planes.
	dc.w	0	; Reserved.
	dc.w	0	; Reserved.
	dc.w	0	; Reserved.
	
;MFDB for screen.

mfdb_s:	dc.l	0
	dc.w	320
	dc.w	200
	dc.w	40
	dc.w	0
	dc.w	4
	dc.w	0
	dc.w	0
	dc.w	0

; Icon image data.

icon:	dc.w $0000,$0000,$FFFF,$0000,$7FFE,$7FFE,$8181,$0180
	dc.w $7FFE,$7E7E,$8241,$0240,$7FFE,$7C3E,$8421,$0420
	dc.w $7FFE,$781E,$8811,$0810,$7FFE,$700E,$9009,$1008
	dc.w $7FFE,$6006,$A005,$2004,$7FFE,$4002,$C003,$4002
	dc.w $7FFE,$4002,$C003,$4002,$7FFE,$781E,$F81F,$781E
	dc.w $7FFE,$781E,$8811,$0810,$7FFE,$781E,$8811,$0810
	dc.w $7FFE,$781E,$8811,$0810,$7FFE,$781E,$8811,$0810
	dc.w $7FFE,$781E,$8811,$0810,$7FFE,$781E,$8811,$0810
	dc.w $7FFE,$7FFE,$8FF1,$0FF0,$0000,$0000,$FFFF,$0000

        bss

        even

; Variables.

gr_handle       ds.w    1
vws_handle      ds.w    1

width:		ds.w	1
color:		ds.w	1
ends:		ds.w	1
type:		ds.w	1
x1:		ds.w	1
y1:		ds.w	1
x2:		ds.w	1
y2:		ds.w	1
height:		ds.w	1
bang:		ds.w	1
eang:		ds.w	1
radius:		ds.w	1
interior:	ds.w	1
style:		ds.w	1
h_factor:	ds.w	1
v_factor:	ds.w	1
t_factor:	ds.w	1
effect:		ds.w	1
b_effect:	ds.w	1
n_effect	ds.w	1
angle:		ds.w	1
x:		ds.w	1
y:		ds.w	1

; Global array.

global:
ap_version:     ds.w    1
ap_count:       ds.w    1
ap_id:          ds.w    1
ap_private:     ds.l    1
ap_ptree:       ds.l    1
ap_1resv:       ds.l    1
ap_2resv:       ds.l    1
ap_3resv:       ds.l    1
ap_4resv:       ds.l    1

; GEM arrays.

control:        ds.w    12
int_in:         ds.w    128
int_out:        ds.w    128
addr_in:        ds.l    64
addr_out:       ds.l    64
pts_in:         ds.w    128
pts_out:        ds.w    128

; Stack.

                ds.l    255
stack:          ds.l    1

